<template>
<div id="wrapper">
  
  <!-- <tree id="my-tree-id" ref="my-tree-ref" :custom-options="myCustomOptions" :custom-styles="myCustomStyles" :nodes="treeDisplayData" /> -->
  <div class="tree-wrapper">
    <div style="color:#aaa">{{project.path}}</div>
    <tree class="file-tree" :path="project.path" :alreadyOpened="true" /><!-- :nodes="fileNodes" :custom-styles="fileTreeStyle" />< !-- id="file-tree-id" ref="file-tree-ref" -->
  </div>

  <div class="content-wrapper">
    <!-- <tabs v-model="activeTab" /> -->
    <vue-tabs-chrome ref="tab" theme="custom" v-model="activeTab" :tabs="tabs" />
    <!-- <component :is="editor">
    < !-- <router-view :editor.sync="editor" /> -- >
    </component>  -->
    <!-- <div>testi after</div> -->
    <codemirror v-if="!visuallyDevelopped" class="editor" @ready="onEditorReady" @input="onEditorInput" :value="editorValue" :options="editorOptions" />
    <!-- <fabric-canvas v-show="visuallyDevelopped" ref="canvas" id="canvas"> -->
      <!-- <fabric-image-from-URL
        :id="/*'el-'+*/item.a"
        :key="item.a"
        v-for="item in items"
        url="/img/button.png"
        :left="item.l + LEFTOFFSET"
        :top="item.t"
        :hasRotatingPoint="false"
        @modified="modified"
        @selected="onSelected"
        @deselected="onDeselected"
        @moving="onDragging"
        :select="selEl==item"
        @keyup.delete="this.console.log(item.a)"
      /> -->
      <!-- <fabric-image-from-URL
        id="button_id"
        url="/img/button.png"
        :left="item.x + LEFTOFFSET"
        :top="item.y"
        :hasRotatingPoint="false"
        @modified="onModified"
        @moving="onDragging"
        @keyup.delete="this.console.log('todo: remove', item)"
      />
    </fabric-canvas> -->
    
    <lambda-format-exporter :root="project.formatExporterRoot" />
  </div>

</div>
</template>

<script>
  import Quill from 'quill'
  // import Warn from './components/warnDev' // "Pseudo anti asserts" for quicker error detection during development
  import Tabs from './components/Tabs'
  import XRegExp from 'xregexp'
  // import Tree from 'vuejs-tree'
  import Tree from './components/Tree'
  import LambdaFormatExporter from './components/LambdaFormatExporter'
  // import FileBrowserTree from 'vue-file-tree' // "vue-file-tree": "github:robogeek/vue-file-tree",
  import { messageBus } from './main.js'
  import { codemirror } from 'vue-codemirror'
  // import vueFabricWrapper from 'vue-fabric-wrapper'

  // codemirror dependencies
  import 'codemirror/addon/mode/overlay'
  import 'codemirror/addon/mode/simple'
  import 'codemirror/lib/codemirror.css'
  import 'codemirror/mode/yaml/yaml'
  import 'codemirror/mode/gfm/gfm'
  // import 'codemirror/mode/markdown/markdown'
  import 'codemirror/addon/selection/active-line'

  import 'codemirror/theme/base16-dark.css'
  // import 'codemirror/theme/yeti.css'
  import 'codemirror/theme/elegant.css'

  // import 'codemirror/addon/fold/foldgutter.css'
  // import 'codemirror/addon/fold/brace-fold.js'
  // import 'codemirror/addon/fold/comment-fold.js'
  // import 'codemirror/addon/fold/foldcode.js'
  // import 'codemirror/addon/fold/foldgutter.js'
  // import 'codemirror/addon/fold/indent-fold.js'
  // import 'codemirror/addon/fold/markdown-fold.js'

  // import VueTabsChrome from 'vue-tabs-chrome'

  const { ipcRenderer } = require('electron')
  
  export default {
    name:       'editor',
    // components: { Warn, Tabs, FileBrowserTree },
    components: {
      Tabs,
      Quill,
      Tree,
      LambdaFormatExporter,
      codemirror,
      // FabricCanvas:       vueFabricWrapper.FabricCanvas,
      // FabricImageFromURL: vueFabricWrapper.FabricImageFromURL,
    },
    data () {
      return {
        activeTab:   null,
        // activeNew:   false,
        editor:      null,
        // text:        '',
        editorValue: '',
        // item:        { x:50, y:50, width:200, height:40 }, // placeholder
        // items:       [], // UI items placeholder
        // fileInfo:    '',
        // nodes:       [],
        // fileNodes:   [ { text:'Root 1', nodes:[ { text:'Child1' }, { text:'Child2' } ] } ],
        // { label:'testi2', key:'testi2', closeable: true, /* favico: require('./assets/google.jpg')*/ },
        // { label:'testi3', key:'testi3', /* favico: require('./assets/google.jpg')*/ },
        composition: [
        ],
        project: {
          path:               'C:\\Projekte\\basic-y\\projs\\html',
          formatExporterRoot: 'C:\\Projekte\\basic-y\\projs\\html\\ifaces\\button.y', // impls\\impl.y',
        },
        fileTreeStyle: {
          height:   '2000px',
          maxWidth: '200px',
        },
        focus,
        tabs: [
          // { label:'testi1', key:'google1', closeable:false },
          // { label:'testi1', key:'google2', closeable:false },
        ],
      }
    },
    computed: {
      activeTabComp () {
        if (!this.activeTab)
          return {}
        return this.tabs.find(o => o.key === this.activeTab)
      },
      visuallyDevelopped () {
        return false
      },
      editorOptions () {
        return {
          addModeClass: true,
          // viewportMargin: 'infinity',
          extraKeys:    {
            // use spaces instead of tabs
            // https://github.com/codemirror/CodeMirror/issues/988#issuecomment-14921785
            'Shift-Tab': (instance) => {
              instance.indentSelection('subtract')
            },
            Tab: (instance) => {
              if (instance.somethingSelected()) {
                instance.indentSelection('add')
              } else {
                instance.replaceSelection(Array(instance.getOption('tabSize') + 1).join(' '), 'end', '+input')
              }
            },
          },
          // indentUnit: this.config.tabSize,
          indentUnit:     2,
          indentWithTabs: false,
          lineNumbers:    true,
          gutter:         true,
          // keyMap: this.keyMap,
          // lineWrapping: true,
          // mode:
          //   'text/yaml',
          mode:           {
            name:                'yaml',
            highlightFormatting: true,
          },
          // mode: {
          //   name: this.config.mode,
          //   highlightFormatting: true,
          // },
          singleCursorHeightPerLine: true,
          // tabSize: this.config.tabSize,
          theme:                     'elegant',
          // theme:                     'base16-dark',
          // theme:                     'yeti',
        }
      },
    },

    mounted () {
      // this.canvas = new fabric.Canvas('canvas', { preserveObjectStacking:true })
      // const canvas = this.canvas
    },
    created () {
      // constants
      this.LEFTOFFSET = 0

      // subscriptions
      ipcRenderer.on('request', this.onRequest)
      window.addEventListener('keydown', this.onKey)
      window.addEventListener('focusin', this.onFocus)
      window.addEventListener('focusout', this.offFocus)
      // window.addEventListener('resize', this.onResize)
      messageBus.$on('fileOpen', this.onFileOpenRequest)
      // (fn, stat) => {
      //   this.$refs.filetree.addPathToTree(fn, stat, false)
      // })
      // messageBus.$on('directory', (fn, stat) => {
      //   this.$refs.filetree.addPathToTree(fn, stat, true)
      // })

      // Quicker testing already opened file
      this.$nextTick(() => {
        console.log('Root', this.project.formatExporterRoot)
        this.openFile(this.project.formatExporterRoot)
        // this.editorValue = require('fs').readFileSync(String(val), 'utf8')
      })
    },
    beforeDestroy () {
      // window.removeEventListener('resize', this.onResize)
      messageBus.$off('fileOpen')
      window.removeEventListener('focusout', this.offFocus)
      window.removeEventListener('focusin', this.onFocus)
      window.removeEventListener('keydown', this.onKey)
      ipcRenderer.removeAllListeners()
    },

    watch: {
      activeTab (val) {
        console.log('active:', val, 'tab:', this.activeTabComp) // debug
        // this.editor = this.getEditorForFile(val)
        // this.fileContents

        // TODO: FileExists ( String(val) )

        // TODO: Evtl nicht jedes Mal direkt lesen!
        if (!val)
          this.editorValue = ''

        else if (this.activeTabComp) {
          if (!this.activeTabComp.text) {
            console.warn('new', this.activeTabComp)
            const text = require('fs').readFileSync(String(val), 'utf8')
            // this.text = this.editorValue = this.activeTabComp.text
            this.activeTabComp.text = text
            this.editorValue = text
            // this.activeNew = false
          }
          // this.text = this.editorValue = this.activeTabComp.text
          this.editorValue = this.activeTabComp.text
        }
      },
    },
    methods: {

      // getEditorForFile (file) {
      //   return 'div'
      // },

      // open (link) { this.$electron.shell.openExternal(link) },
      offFocus () { this.focus = null },
      onFocus (e) { this.focus = e.target },
      onRequest (event, data) {
        // if () TODO: is_array
        switch (data[0]) {
          case 'openFile': this.openFile(String(data[1])); break
          case 'save': this.save(); break
          default: console.error('Unknown request:', data)
        }
      },

      onFileOpenRequest (data) { this.openFile(data[0]) },
      openFile (filePath) {
        // TODO: Auf Größe der Datei achten, bei ~ > 1MB nur teilweise laden / als stream verarbeiten
        // TODO: Async / Check if file exists etc.
        // const rawdatautf8 = require('fs').readFileSync(filePath, 'utf8')
        // console.log(filePath, '-->', rawdatautf8.length < 100 ? rawdatautf8 : (rawdatautf8.substring(0, 100)+' ...'))
        var tab = this.tabs.find(o => o.key === filePath) // find((obj, index) => ...)
        if (!tab) {
          tab = { label:this.dir(filePath), key:filePath, closeable:true }
          // this.tabs.push(tab)
          this.$refs.tab.addTab(tab)
        }
        // this.activeNew = true
        this.activeTab = filePath
      },
      dir (path) { // duplicate function exists (Tree.vue)
        if (!path)
          return ''
        const lastSeparator = Math.max(path.lastIndexOf('/'), path.lastIndexOf('\\'))+1
        // console.log('lastSep', lastSeparator)
        return path.substring(lastSeparator)
      },
      save () {
        if (!this.activeTabComp) {
          console.warn('Save Befehl, aber kein aktiver Tab!')
          return
        }
        const text = this.activeTabComp.text // || ''
        require('fs').writeFileSync(this.activeTab, text, 'utf8')
        this.editorValue = text
        if (this.activeTabComp.label.endsWith(' *'))
          this.activeTabComp.label = this.activeTabComp.label.substring(0, this.activeTabComp.label.length-2)
      },

      // // UI methods
      // onModified (event) {

      // },
      // onDragging (event) {

      // },

      onEditorReady (instance) {
        this.editor = instance
        if (this.activeTabComp) // <- INFO: nur bedingtes editor.getValue() setzen könnte ggf in edge-cases zu Problemen führen (-> TODO: tests)
          this.activeTabComp.text = this.editor.getValue()
        // this.$emit('ready', instance) // falls als eigene Komponente
      },
      onEditorInput (text) {
        // this.text = text
        const tab = this.activeTabComp // this.tabs.find(o => o.key === this.activeTab)
        // tab.unsafed = true
        if (!tab || !tab.label) {
          console.warn('Editor Input, aber kein aktiver Tab gesetzt!!', tab)
          return
        }

        if (!tab.label.endsWith(' *') && tab.text && tab.text !== this.editorValue)
          tab.label += ' *'

        tab.text = text
        // console.log(this.text, this.editorValue)
        // this.$emit('input', text)
      },

      onKey (e) {
        // e.preventDefault()
        // console.log(this.focus)

        // Cancel if any text-field focused, other than the main one
        // if (this.focus !== this.$refs.qc && this.focus && this.focus.nodeName==='INPUT' && this.focus.type==='text')
        //   return

        // Don't perform side-effects on (only) Shift, Alt, etc.
        if (e.key === 'Shift' || e.key === 'Control' || e.key === 'Alt') return
        if (e.key === 'Tab') {
          console.log('send request')
          ipcRenderer.send('request', 'testiiii')
          return
        }

        // Process only if focussed
        if (this.focus === this.$refs.qc && e.key === 'Enter') {
          // this.history.push(this.$refs.qc.value)
          // this.historyOffset = this.history.length - 1
          this.$refs.qc.value = this.evaluateQuickcode(this.$refs.qc.value /* this.selected */)
        }

        // Key combinations / shortcuts
        this.evaluateShortcuts(e) // e.g. "Alt + Enter"
      },
      evaluateShortcuts (e) {
        // var alt = e.altKey // <- OSX, etc.
        // var selectIndex = this.openedComp.c.indexOf(this.selected)
        // var sheikhFactor = this.openedComp.c.length // amount of children

        console.log('Keyevent:', e)

        // if (alt)
        //   switch (e.key) {
        //     // Alt + Delete
        //     case 'Delete': this.deleteComponent(); break

        //     // Alt + Up / Down
        //     case 'ArrowUp':
        //       if (this.openedComp.c.length > 0)
        //         this.selectIndex = (this.selectIndex <= -1) ?this.openedComp.c.length-1 :this.selectIndex-1
        //       console.log('SEL COMP:', this.selectComp)
        //       break

        //     case 'ArrowDown':
        //       if (this.openedComp.c.length > 0)
        //         this.selectIndex = (this.selectIndex >= this.openedComp.c.length-1) ?-1 :this.selectIndex+1 // this.selected = (selectIndex === sheikhFactor-1) ?this.openedComp.c[0] :this.openedComp.c[selectIndex-1]
        //       break

        //     // Alt + Right [or]
        //     // Alt + Enter
        //     case 'Enter': // <== also the quickcode statement is evaluated beforehand
        //     case 'ArrowRight':
        //       this.$electron.ipcRenderer.send('ping')
        //       console.log('selIndex', this.selectIndex)
        //       // console.log('toopen:', (this.selectIndex === -1)) // openedComp === this.selected.z))
        //       // // ? (this.openedComp.c[this.openedComp.c.length-1].comp)
        //       // // : (this.selected.comp))
        //       // console.log('letztes el:', this.openedComp.c[this.openedComp.c.length-1].z)
        //       // console.log('selectedel:', this.selected.z)
        //       // console.log('openedComp:', this.openedComp)
        //       if (this.openedComp.c.length === 0) break
        //       if (this.selectIndex === -1) break
        //       this.ancestors.push(this.openedComp)
        //       this.openedComp = this.selectComp
        //       this.selectIndex = -1
        //       // console.log('selected.comp', this.selected.comp)
        //       // this.openComponent(this.selectIndex === -1
        //       //   ? this.openedComp.c[this.openedComp.c.length-1].z
        //       //   : this.selected.z)
        //       break

        //     // Alt + Left [or]
        //     // Alt + Escape (possibly reconsider?)
        //     case 'Escape':
        //     case 'ArrowLeft':
        //       let newTarget = this.ancestors.length
        //         ? this.ancestors.pop()
        //         : this.composition[0]
        //       // set previous child component as selected
        //       this.selectIndex = newTarget.c.findIndex(inst => inst.z===this.openedComp)
        //       // (newTarget.c.indexOf(this.openedComp)!==-1)
        //       //   ? newTarget.c.indexOf(this.openedComp)
        //       //   : -1
        //       this.openedComp = newTarget
        //       break
        //   }
        // if (e.key === 'ArrowUp') {
        //   if (this.historyOffset <= 0) return
        //   if (this.historyOffset === this.history.length - 1) this.history.push(this.$refs.qc.value)
        //   this.$refs.qc.value = this.history[--this.historyOffset]
        //   e.preventDefault()
        // }
        // if (e.key === 'ArrowDown') {
        //   if (this.historyOffset === this.history.length - 1 && this.$refs.qc.value.trim() === '') return
        //   if (this.historyOffset === this.history.length - 1) this.history.push('')
        //   this.$refs.qc.value = this.history[this.historyOffset++]
        //   e.preventDefault()
        // }
      },
      // TODO: E.g. cick-handlers should also call 'evaluateQuickcode' with code which is evaluated here
      evaluateQuickcode (code /* selected */) {
        // var assert = require('assert')
        // assert(selected !== null)
        // alert('evaluate: ' + code + ', for: ' + selected)

        // -------------------------------------------------------------------------------------- //

        // Execute multiple commands (recursively)
        if (code.indexOf(';') !== -1) {
          // console.log('Multiple commands:', code)
          code.split(';').forEach(val => { if (this.evaluateQuickcode(val) !== '') return code })
          return ''
        }

        // Basic command evaluation (via regex)
        // const regex = /^(\?[^:]*)?: *([\w \u00C0-\u02AF]*):?([\w \u00C0-\u02AF]*)(?:\*([1-9][0-9]?|100))? *$/g
        // const regex = XRegExp(`^ *(\\? *\\pL(?:\\pL|[ ])*): *(\\pL(?:\\pL| )*):?(\\pL(?:(\\pL| )*)(?:\\*([1-9][0-9]?|100))? *$`, 'gA') // partial tests ([\w \u00C0-\u02AF]*):?([\w \u00C0-\u02AF]*)(?:\*([1-9][0-9]?|100))? *$`, 'gA') // (A)Astral, (x)free spacing (nu), (s)dot match all (not yet used)
        // const regex = XRegExp(`^(?: *(?:\\?(\\p{L}| )*)? *\\:)?((?:\\p{L}| )*)?(?:\\: *(\\p{^C}*))?(?:\\*([1-9][0-9]?|100))? *$`, 'A') // complete but simplified (e.g. trimming necessary), allows for either multiples [e.g. comp*4] OR description [e.g. comp:This is a desc with: colon]

        // Structuring ideas (grouping?)
        // const basic = {
        //   cond: '^\\?$',
        //   comp: '^ *$',
        //   desc: XRegExp('^\\p{^C}*$'),
        // }
        // const regex = XRegExp.build('^{{add}}|{{rename}}$', {
        //   add:    XRegExp.build('^ *{{cond}}\\: *{{comp}} *(\\:{{desc}})?$', basic),
        //   rename: XRegExp.build('^\\: *{{comp}}$', basic),
        // }, 'A')

        // TODO: Possibly, rework if multiline entries are allowed
        const regex = XRegExp.build(/^(?:{{cond}}|{{list}})?{{name}}{{mult}}?{{desc}}?$|^{{desc}}$|^{{cond}}$/, { // (?:{{desc}}|{{mult}})?$/, { // *(\\:{{desc}})?$', {
        // const regex = XRegExp.build(/^{{cond}}?{{name}}{{mult}}?{{desc}}?$|^{{desc}}$/, { // working well
          cond: /^\? *((?:\pL| )*?) *\: *$/, // Only letters and spaces ("trimmed"), also empty ("?:") allowed!
          list: /^\* *((?:\pL| )*?) *\: *$/,
          // loop: /^\*$/,
          // comp: /^ *(\pL(?:\pL| )*?) *$/, // /^ *(\p{L}*)$/,
          name: /^ *(\pL(?:\pL| )*?) *$/,
          desc: /^\: *([^\x00-\x1A]*?) *$/, // everything except control chars (be careful, still very greedy!)
          mult: /^\* *([1-9][0-9]?|100) *$/,
        }, 'A')

        // console.log(regex.test(code))
        // const match = code.trim().match(regex)
        const match = regex.exec(code)
        // const match = XRegExp.exec(code, regex) // also adds named attributes (e.g. match.cond (when directly surrounded by extra brackets e.g. ({{cond}}) )), but would require lookarounds to get rid of spaces etc.
        console.table(match)
        if (!match)
          return code

        const cond = match[1]
        const list = match[2]
        const name = match[3]
        const desc = match[5]
        const mult = match[4]
        const existing = this.composition.find(e => e.a === name) // find vs some => boolean result
        // console.log('ex', existing)
        const onlyDesc = match[6] // e.g. ":new description"
        const onlyCond = match[7] // e.g. "?new condition:" (works only with/for a selected component instance)

        // if (cond) {
        //   console.log('TODO: implement condition,', cond)
        //   // const condition_regex = /^[\w \u00C0-\u02AF]*==$/g

        //   // XRegExp instead of regex (missing recursive matching, unicode support, and)
        //   const condRegex = XRegExp(``)
        //   console.log(condRegex)
        // }

        // -------------------------------------------------------------------------------------- //

        // asdfvar colon = code.indexOf(':')
        // var quest = code.indexOf('?')

        // switch (code[0]) {
        //   case '<': if (colon!==-1) return code; this.setA(code.substring(1)); return ''
        // }

        // Only change the currently selected description
        if (onlyDesc) {
          this.selectComp.b = onlyDesc
          return ''
        }

        if (onlyCond !== undefined) {
          if (!this.selectInst)
            return code
          this.selectInst.x = onlyCond
          return ''
        }

        // Component name specified
        if (name) {
          // Find existing component, or create new one
          const component = existing || {a:name, b:desc||'', c:[], p:[]}
          if (!existing) this.composition.push(component)

          // Add component to opened component
          for (var i=mult||1; i>0; i--) {
            var inst = {z:component}

            // Add condition, if it was supplied
            if (cond)
              inst.x = cond // simple string, therefore not same instance
            if (list)
              inst.l = list

            // Push separate changeable insts
            this.openedComp.c.push(inst) // this.addComponent(component)
          }

          console.log(this.openedComp.c.length)
          console.log(this.selectIndex)
          if (this.setting.autoselect_new_comp && (this.selectIndex === -1 || this.selectIndex === (this.openedComp.c.length-2))) {
            this.selectIndex = this.openedComp.c.length-1 // select last component
          }
        } else if (desc && mult)
          return code

        // // No colon
        // if (colon === -1)
        //   this.selected.c.push({a:code.trim(), c:[]})
        // // Starting colon
        // else if (colon === 0)
        //   this.setB(code.substring(1)) // assignment without curlies, not that beautiful (change linting?)
        // else {
        //   // s = code.split(':')
        //   // this.selected.c.push({a:code.substring(0, colon).trim(), b:code.substring(colon+1).trim(), c:[]})
        //   this.addC(code.substring(0, colon), code.substring(colon+1)) // , c:[]})
        // }

        return ''
      },
      // setA (a) { this.selected.a = a },
      // setB (b) { this.selected.b = b },
      // addC (a, b) { this.selected.c.push({a:a.trim(), b:b.trim(), c:[]}) },
      // addComponent (comp) {
      //   this.composition.push(comp)
      //   this.selected.c.push({z:comp})
      // },
      // TODO: (Bug) Problems with deleting correct index ...
      deleteComponent () {
        if (!this.openedComp.c[this.selectIndex])
          return
        // Remove the selected component instance and select the one above
        this.openedComp.c.splice(this.selectIndex, 1)
        if (this.selectIndex >= (this.openedComp.c.length)) this.selectIndex--
      },
      // openComponent (comp) {
      //   // if (this.selectIndex === -1 && this.selected.c.length === 0)
      //   //   return

      //   if (!comp)
      //     return

      //   // Store openedComp parent component
      //   this.ancestors.push(this.openedComp)
      //   this.openedComp = comp
      //   this.selectIndex = -1
      // },
    },
  }
</script>

<style src="primevue/resources/themes/saga-blue/theme.css" scoped />
<style src="primevue/resources/primevue.min.css" scoped />
<style src="primeicons/primeicons.css" scoped />
<style>

  /* 
  @import url('https://fonts.googleapis.com/css?family=Source+Sans+Pro');

  * {
    box-sizing: border-box;
    margin: 0;
    padding: 0;
  }
  body { font-family: 'Source Sans Pro', sans-serif; }
  .pad { padding:2.5rem; } 
  */

  #wrapper {
    /* background:
      radial-gradient(
        ellipse at top left,
        rgba(255, 255, 255, 1) 40%,
        rgba(229, 229, 229, .9) 100%
      ); */
    min-height: 100vh; /* min-height because of possible overflow */
    /* padding: 40px 40px; */
    width: 100vw;
    height: 100vh;
  }

  .content-wrapper {
    background:#fff;
    /* background-color:red; */
    /* background:#ECEAE8; */
    /* background:#151515; */
    /* overflow:hidden;
    position:relative;
    top:0px;
    bottom:0px; */
    height:100vh;
    display:flex;
    flex-direction:column;
  }

  .editor {
    overflow:auto;
    height:auto!important;
    flex:1;
    display:flex;
  }
    /* overflow:hidden; */
    /* position:absolute;
    top:0px;
    bottom:0px; */
    /* height:100vh; */
    /* background-color:yellow; */
    /* some styling config also via this.editorOptions */
  /* } */
  .CodeMirror {
    /* overflow-y: scroll !important; */
    height: auto !important;
    font-size: 120%;
    flex:1;
    /* background:blue!important; */
  }
  /* .vue-codemirror  {
    overflow-y: scroll !important;
    height: auto !important;
    border: 2px solid #ddd;
    background-color:blue;
  } */

  .tree-wrapper {
    height:100vh;
    float:left;
    /* width:20vw; */
    width:240px;
    background:#fdfdfd; /* prev f7 */
    
  }
  .tree-wrapper>div { 
    background:#efefef; /* prev df */
    padding: 12px 12px 11px;
  }
  .file-tree {
    padding: 12px 12px;
  }

  .quickcode { margin:10px 0; padding:2px; }

  #logo {
    height: auto;
    margin-bottom: 20px;
    width: 420px;
    /* display: none; */
    display: none;
  }

  .title {
    color: #2c3e50;
    font-size: 20px;
    font-weight: bold;
    margin-bottom: 6px;
    opacity:0.5;
  }

  .subtitle {
    opacity:0.7;
  }

  .intro { margin-top:2rem; }
  .intro p, .intro li{
    font-family: 'Courier New', Courier, monospace;
  }
  .intro h2 {
    color:gray;
    font-family:inherit;
    margin-bottom:1rem;
  }
  .intro>ul {
    margin:0.5rem 2px;
  }

  main {
    display: flex;
    justify-content: space-between;
  }
  main > div { flex-basis: 33%; }

  .left-side {
    /* padding:5rem 5rem 0 0; */
    margin:5.5rem 0;
    flex-basis: 20%;
  }
    /* .p-listbox { } */
    /* .p-listbox-item { } */
    .p-component {
      font-size:1.5rem;
    }

  .center {
    flex-basis:50%;
    display: flex;
    flex-direction: column;
    margin:0 4rem;
    /* background:gray; */
  }

  .right-side {
    flex-basis:30%;
    margin:5.5rem 0rem;
    /* background:blue; */
  }
</style>

<style lang="less">
  .vue-tabs-chrome.theme-custom {
    padding-top: 0;
    background-color: transparent;
    overflow: hidden;

    .tabs-footer,
    .tabs-divider,
    .tabs-background-before,
    .tabs-background-after {
      display: none;
    }

    .tabs-item {
      cursor: pointer;
      .tabs-close { display: none; }
    }
    .tabs-item:hover {
      .tabs-close { display: block;}
    }

    .tabs-content {
      overflow: unset;
      border-bottom: 1px solid #e4e7ed;
    }
    .tabs-background {
      padding: 0;
    }
    .tabs-background-content {
      border-top: 1px solid #e4e7ed;
      border-left: 1px solid #e4e7ed;
      border-right: 1px solid #e4e7ed;
      border-radius: 0;
      background-color: #fff;
    }
    .tabs-content {
      height: 40px;
    }
    .active {
      .tabs-close { display: inline;}
      color: #409eff;
      .tabs-background {
        &::before,
        &::after {
          top: 100%;
          left: 0;
          content: '';
          width: 100%;
          height: 1px;
          background-color: #fff;
          z-index: 1;
          position: absolute;
        }
        &::before {
          top: 0;
          height: 2px;
          background-color: #409eff;
        }
      }
    }
  }

</style>

